#!/usr/bin/perl
# 
# HTTP Parameters module
# by nitr0us (nitrousenador@gmail.com)
# http://chatsubo-labs.blogspot.com
#
# In this module resides the functionality to substitute
# the 'TRAVERSAL' tokens in the supplied URL by the fuzz
# patterns created by the Traversal Engine.
# Once subsituted, the request is sent to the target and the 
# module waits for the response.
# Thereafter, it checks if the string pattern passed as a 
# parameter (-k switch) exists in the server's response, 
# if so, it's considered vulnerable.
# 

package DotDotPwn::HTTP_Url;
use Exporter 'import';
@EXPORT = qw(FuzzHTTP_Url);

use HTTP::Lite;
use Time::HiRes qw(usleep);

sub FuzzHTTP_Url{
	my ($url) = @_;
	my $n_travs = 0;
	my $foo = 0; # Used as an auxiliary variable in quiet mode (see below)

	print "[+] Replacing \"TRAVERSAL\" with the traversals created and sending\n";
	foreach $traversal (@main::traversals){
		my $http = new HTTP::Lite;
		$http->add_req_header("User-Agent", "DotDotPwn v2.1");

		$tmp_url = $url; # Not to overwrite the TRAVERSAL token
		$tmp_url =~ s/TRAVERSAL/$traversal/g;

		if(!$http->request($tmp_url)){
			my $runtime = time - $main::start_time;
			printf "\n[+] Fuzz testing finished after %.2f minutes ($runtime seconds)\n", ($runtime / 60);
			print "[+] Total Traversals found (so far): $n_travs\n";
			die "[-] Web server didn't respond !\n";
		}

		if($http->body() =~ /$main::pattern/s ){
			print "\n[*] Testing URL: $tmp_url <- VULNERABLE\n";
			$n_travs++;

			return $n_travs if $main::break;

			usleep($main::time);
			next;
		}

		if($main::quiet){
			print ". " unless $foo++ % $main::dot_quiet_mode;
		} else{
			print "[*] Testing URL: $tmp_url\n";
		}

		usleep($main::time);
	}

	return $n_travs;
}
